require 'Camping/CCampfireSystem'

local lastX = -1;
local lastY = -1;
local lastState = false;
---------------------------------------- Common ----------------------------------------

-- Check if player position changed with accuracy of 1/100 of a square 
-- Need this cause game spams OnTest events
function HandyRecipes_IsPlayerMoved()
	local player = getPlayer();
	local newX = math.ceil(player:getX()*100);
	local newY = math.ceil(player:getY()*100);
	if newX == lastX and newY == lastY then
		return nil;
	end--if
	lastX = newX;
	lastY = newY;
	return player;
end--function

---------------------------------------- OnTest ----------------------------------------

-- Cheks if there is a lit campfire near player
function HandyRecipes_IsCampfireLit(sourceItem, result)
	local player = HandyRecipes_IsPlayerMoved();
	if player == nil then
		return lastState;
	end--if
	lastState = false;
	local px = player:getCurrentSquare():getX();
	local py = player:getCurrentSquare():getY();
	local pz = player:getCurrentSquare():getZ();
	for y = py-1, py+1 do
		for x = px-1, px+1 do	
			local sq = getCell():getGridSquare(x, y, pz);
			if sq then
				local obj = CCampfireSystem.instance:getLuaObjectOnSquare(sq);
				if obj and obj.isLit then
					lastState = true;
					return lastState;
				end--if
			end--if
		end--for
	end--for
	return lastState;
end--function

---------------------------------------- OnGiveXp ----------------------------------------

function HandyRecipes_GiveWeldingXP_3(recipe, ingredients, result, player)
	player:getXp():AddXP(Perks.MetalWelding, 3);
end--function

function HandyRecipes_GiveWeldingXP_5(recipe, ingredients, result, player)
	player:getXp():AddXP(Perks.MetalWelding, 5);
end--function

function HandyRecipes_GiveTailoringXP_1(recipe, ingredients, result, player)
	player:getXp():AddXP(Perks.Tailoring, 2);
end--function

function HandyRecipes_GiveTailoringXP_3(recipe, ingredients, result, player)
	player:getXp():AddXP(Perks.Tailoring, 4);
end--function

function HandyRecipes_GiveCookingXP_2(recipe, ingredients, result, player)
	player:getXp():AddXP(Perks.Cooking, 2);
end--function
